// Copyright 2017 Baliance. All rights reserved.
//
// DO NOT EDIT: generated by gooxml ECMA-376 generator
//
// Use of this source code is governed by the terms of the Affero GNU General
// Public License version 3.0 as published by the Free Software Foundation and
// appearing in the file LICENSE included in the packaging of this file. A
// commercial license can be purchased by contacting sales@baliance.com.

package dml

import (
	"encoding/xml"

	"github.com/unidoc/unioffice"
)

type EG_LineDashProperties struct {
	PrstDash *CT_PresetLineDashProperties
	CustDash *CT_DashStopList
}

func NewEG_LineDashProperties() *EG_LineDashProperties {
	ret := &EG_LineDashProperties{}
	return ret
}

func (m *EG_LineDashProperties) MarshalXML(e *xml.Encoder, start xml.StartElement) error {
	if m.PrstDash != nil {
		seprstDash := xml.StartElement{Name: xml.Name{Local: "a:prstDash"}}
		e.EncodeElement(m.PrstDash, seprstDash)
	}
	if m.CustDash != nil {
		secustDash := xml.StartElement{Name: xml.Name{Local: "a:custDash"}}
		e.EncodeElement(m.CustDash, secustDash)
	}
	return nil
}

func (m *EG_LineDashProperties) UnmarshalXML(d *xml.Decoder, start xml.StartElement) error {
	// initialize to default
lEG_LineDashProperties:
	for {
		tok, err := d.Token()
		if err != nil {
			return err
		}
		switch el := tok.(type) {
		case xml.StartElement:
			switch el.Name {
			case xml.Name{Space: "http://schemas.openxmlformats.org/drawingml/2006/main", Local: "prstDash"},
				xml.Name{Space: "http://purl.oclc.org/ooxml/drawingml/main", Local: "prstDash"}:
				m.PrstDash = NewCT_PresetLineDashProperties()
				if err := d.DecodeElement(m.PrstDash, &el); err != nil {
					return err
				}
			case xml.Name{Space: "http://schemas.openxmlformats.org/drawingml/2006/main", Local: "custDash"},
				xml.Name{Space: "http://purl.oclc.org/ooxml/drawingml/main", Local: "custDash"}:
				m.CustDash = NewCT_DashStopList()
				if err := d.DecodeElement(m.CustDash, &el); err != nil {
					return err
				}
			default:
				unioffice.Log("skipping unsupported element on EG_LineDashProperties %v", el.Name)
				if err := d.Skip(); err != nil {
					return err
				}
			}
		case xml.EndElement:
			break lEG_LineDashProperties
		case xml.CharData:
		}
	}
	return nil
}

// Validate validates the EG_LineDashProperties and its children
func (m *EG_LineDashProperties) Validate() error {
	return m.ValidateWithPath("EG_LineDashProperties")
}

// ValidateWithPath validates the EG_LineDashProperties and its children, prefixing error messages with path
func (m *EG_LineDashProperties) ValidateWithPath(path string) error {
	if m.PrstDash != nil {
		if err := m.PrstDash.ValidateWithPath(path + "/PrstDash"); err != nil {
			return err
		}
	}
	if m.CustDash != nil {
		if err := m.CustDash.ValidateWithPath(path + "/CustDash"); err != nil {
			return err
		}
	}
	return nil
}
